# Copyright (c) 2009 Adam Tauno Williams <awilliam@whitemice.org>
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in
# all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
# THE SOFTWARE.
#
class UserAgent(object):

    def __init__(self, user_agent):
        if (user_agent is None):
            user_agent = 'Generic'
        else:
            agent_name    = user_agent.split('/')[0].lower()
            agent_version = user_agent.split('/')[1].lower()

        if (agent_name in ['gvfs', 'curl', 'bionicmessage.net jgroupdav', 'Mozilla']):
            self._supports_301 = False
        else:
            self._supports_301 = True

        if (agent_name in ['evolution']):
            self._supports_memos = True
        else:
            self._supports_memos = False

    @property
    def supports_301(self):
        return self._supports_301

    @property
    def supports_memos(self):
        return self._supports_memos
